using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections.Specialized;
using Syncfusion.Grouping;

namespace WindowsApplication14
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            #region Get the DataSource
            DataTable dt = new DataTable("MyTable");

            int nCols = 4;
            int nRows = 20;
            Random r = new Random(123345345);

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(string)));

            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                {
                    if (j == 0)
                    {
                        dr[0] = ((i % 3) == 0) ? "Enabled" : "Disabled";
                    }
                    else
                    {
                        dr[j] = r.Next(10000);
                    }
                }
                dt.Rows.Add(dr);
            }
            #endregion

            this.gridGroupingControl1.DataSource = dt;

            StringCollection list = new StringCollection();
            list.AddRange(new string[] {"Enabled", "Disabled"});

            this.gridGroupingControl1.TableDescriptor.Columns["Col0"].Appearance.AnyRecordFieldCell.CellType = "ComboBox";
            this.gridGroupingControl1.TableDescriptor.Columns["Col0"].Appearance.AnyRecordFieldCell.ChoiceList = list;
            this.gridGroupingControl1.TableDescriptor.Columns["Col0"].Width = 100;
          //  this.gridGroupingControl1.TableDescriptor.Columns["Col0"].FieldDescriptor.ForceImmediateSaveValue = true;

            this.gridGroupingControl1.QueryCellStyleInfo += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventHandler(gridGroupingControl1_QueryCellStyleInfo);
          
            this.gridGroupingControl1.TableControlCellMouseDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventHandler(gridGroupingControl1_TableControlCellMouseDown);
            this.gridGroupingControl1.TableControlCurrentCellCloseDropDown += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventHandler(gridGroupingControl1_TableControlCurrentCellCloseDropDown);
         }

        void gridGroupingControl1_TableControlCurrentCellCloseDropDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlPopupClosedEventArgs e)
        {
            Record rec = gridGroupingControl1.Table.CurrentRecord;
            if (rec != null)
                rec.EndEdit();
        }

        void gridGroupingControl1_TableControlCellMouseDown(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlCellMouseEventArgs e)
        {
            if (gridGroupingControl1.TableControl.CurrentCell != null)
            {
                gridGroupingControl1.TableControl.CurrentCell.CloseDropDown(Syncfusion.Windows.Forms.PopupCloseType.Deactivated);
            }
        }

        

        void gridGroupingControl1_QueryCellStyleInfo(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableCellStyleInfoEventArgs e)
        {
            Record rec = e.TableCellIdentity.DisplayElement.GetRecord();
            if (rec != null)
            {
                if (e.TableCellIdentity.Column != null)
                {
                    string colName = e.TableCellIdentity.Column.Name;
                    if (colName != "Col0")
                    {
                        object o = rec.GetValue("Col0");
                        if (o != null && o.ToString() == "Disabled")
                        {
                            e.Style.Enabled = false;
                            e.Style.BackColor = Color.LightGoldenrodYellow;
                        }
                    }
                }
            }
        }

       
    }
}